'Utilisation d'numrateurs pour imprimer les informations relatives 
'  un salari dans VB .NET
'Copyright (c)2001 by Bischof Systems, Inc.

Module Module1
    <Flags()> Enum EnregistrementSalari
        'Le prfixe "&H" indique une constante hexadcimale
        Employ = &H1
        Cadre = &H2
        Comptabilit = &H4
        Publicit = &H8
    End Enum

    Sub Main()
        Dim Salari As EnregistrementSalari
        'Crer une variable reprsentant un cadre du service Comptabilit
        'Utiliser un oprateur OR binaire pour les ajouter
        Salari = EnregistrementSalari.Cadre Or EnregistrementSalari.Comptabilit
        'Affiche les informations sur la personne
        ShowInfo("Joe Jones", Salari)
        'Crer une variable reprsentant un employ du service Publicit
        'Utiliser un oprateur OR binaire pour les ajouter
        Salari = EnregistrementSalari.Employ Or EnregistrementSalari.Publicit
        'Affiche les informations sur la personne
        ShowInfo("Mary Jane", Salari)
        Console.ReadLine()
    End Sub

    Sub ShowInfo(ByVal Nom As String, ByVal Salari As EnregistrementSalari)
        Dim fonction, service As EnregistrementSalari
        Dim toutesFonctions, tousServices As EnregistrementSalari
        'Utiliser un oprateur binaire OR pour rcuprer les bits 
        'reprsentant la fonction ou le service
        toutesFonctions = EnregistrementSalari.Employ Or EnregistrementSalari.Cadre
        tousServices = EnregistrementSalari.Comptabilit Or _
            EnregistrementSalari.Publicit
        'Utiliser un oprateur binaire AND pour filtre les bits de l'autre zone
        fonction = Salari And toutesFonctions
        service = Salari And tousServices
        'Affiche le nom et les infos sur le salari
        Console.WriteLine()
        Console.WriteLine("Salari : {0}", Nom)
        Console.Write("Fonction : ")
        Console.WriteLine(fonction.ToString())
        Console.Write("Service : ")
        Console.WriteLine(service.ToString())
    End Sub
End Module

