VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Exemple d'application copiant un fichier en Visual Basic 6.0
'Copyright (c)2001, Bischof Systems, Inc.
Sub Main()
    Dim CopieTermine As Boolean
    Dim NomSource, NomDestination As String
    CopieTermine = True
    Do
        On Error GoTo GestionErreur
        'Remplacer la valeur en cas d'chec prcdent
        CopieTermine = True
        'Lire les noms de fichiers et copier
        NomSource = InputBox("Nom du fichier source : ")
        NomDestination = InputBox("Nom du fichier de destination : ")
        CopierFichier NomSource, NomDestination
    Loop While (Not CopieTermine)
Fin:
        Debug.Print "Copie du fichier termine"
        Exit Sub
GestionErreur:
        Select Case Err.Number
        Case 53 'Fichier inexistant
            Debug.Print "Fichier source inexistant : " + NomSource
            'Inviter l'utilisateur  ressaisir le nom du fichier
            CopieTermine = False
            Resume Next
        Case vbObjectError + 1
            Debug.Print Err.Description
        Case Else
            Debug.Print "Erreur inattendue : " + Err.Description
        End Select
        GoTo Fin
End Sub
'Copier un fichier vers un autre
Private Sub CopierFichier(ByVal NomSource As String, ByVal NomDestination _
    As String)
    Dim FichierSource As Integer
    Dim FichierDestination As Integer
    Dim FichierDestinationPrt As Boolean
    Dim CompteurLigne As Integer
    Dim TexteFichier As String
    Dim LigneCourante As Integer
    FichierSource = FichierLibre
    Open NomSource For Input As #FichierSource
    FichierDestination = FichierLibre
    Do
        On Error Resume Next
        'Ouvrir le fichier de destination pour la sortie
        Open NomDestination For Output As #FichierDestination
        If Err = 0 Then
            'Ouverture du fichier russie
            FichierDestinationPrt = True
        Else
            'Le fichier existe dj, le supprimer
            File.Delete NomDestination
            Err.Clear
        End If
    Loop While (Not FichierDestinationPrt)
    ' ce stade tout ce qui se passe concerne les fichiers ouverts.
    'Fermer les fichiers en cas d'erreur.
    On Error GoTo Fin
    'Les deux fichiers tant ouverts, effectuer la copie
    Input #FichierSource, CompteurLigne
    Print #FichierDestination, CompteurLigne
    For LigneCourante = 1 To CompteurLigne
    Input #FichierSource, TexteFichier
        If (TexteFichier = "") Then
            Err.Raise vbObjectError + 1, , "En-tte du fichier source invalide"
        End If
        Print #FichierDestination, TexteFichier
    Next
Fin:
    'Fermer tous les fichiers ouverts
    Close #FichierSource
    Close #FichierDestination
    If Err <> 0 Then
        Select Case Err.Number
        Case 62
            Err.Raise vbObjectError + 1, , "En-tte du fichier source non valide"
        Case Else
            Err.Raise Err.Number, , Err.Description
        End Select
    End If
End Sub


