'Calcul du prix de vente en Visual Basic .NET
'Copyright (c)2001, Bischof Systems, Inc.

Module Module1
    Sub Main()
        Dim Magazine As New Article("Magazine")
        Dim Bestseller As New Livre()
        PrintInfo(Magazine, 10)
        PrintInfo(Bestseller, 5, 15)
        Console.ReadLine()
    End Sub
    Public Sub PrintInfo(ByVal Produit As Article, ByVal Prix As Double)
        Console.WriteLine("Prix de 1 {0} : {1}", Produit.Description, _
            Produit.PrixTotal(Prix))
    End Sub
    Public Sub PrintInfo(ByVal Produit As Article, ByVal Qt As Integer, _
        ByVal Prix As Double)
        Console.WriteLine("Prix de {0} {1}S : {2}", Qt, _
            Produit.Description, Produit.PrixTotal(Qt, Prix))
    End Sub

    Public Class Article
        Public Description As String
        'Code du constructeur - Imposer le nom en lettres majuscules
        Public Sub New()
            Me.New("")
        End Sub
        Public Sub New(ByVal Description As String)
            Me.Description = Description.ToUpper()
        End Sub
        'Calculer le prix total de tous les articles - quantit facultative
        Public Overridable Function PrixTotal(ByVal Prix As Double) As Double
            Return Me.PrixTotal(1, Prix)
        End Function

        Public Overridable Function PrixTotal(ByVal Qt As Integer, _
            ByVal Prix As Double) As Double
            Return Qt * Prix
        End Function
    End Class

    'Classe calculant le prix des livres
    Public Class Livre
        Inherits Article
        'Code du constructeur
        Public Sub New()
            'En labsence de description, utiliser "Livre" par dfaut
            Me.New("Livre")
        End Sub
        Public Sub New(ByVal Description As String)
            MyBase.New(Description)
        End Sub
        'Livres vendus avec une remise de 25 %
        Public Overloads Overrides Function PrixTotal(ByVal Qt As Integer, _
            ByVal Prix As Double) As Double
            Dim Total As Double
            Total = MyBase.PrixTotal(Qt, Prix)
            Total *= 0.75
            Return Total
        End Function
    End Class
End Module

