'Gestion dun compte courant en Visual Basic .NET
'Copyright (c)2001, Bischof Systems, Inc.

Module Module1
    'Dclarer la classe pour quelle identifie les vnements
    Private WithEvents CompteCourant As CCompteCourant

    Sub Main()
        CompteCourant = New CCompteCourant(100)
        'Sabonner  lvnement Alerte avec linstruction AddHandler
        AddHandler CompteCourant.Alerte, AddressOf AlerteTransaction
        CompteCourant.Dpt(500)
        CompteCourant.Retrait(400)
        CompteCourant.Retrait(75)
        CompteCourant.Retrait(50)
        Console.ReadLine()
    End Sub

    'Grer lvnement CompteCourant.Alerte
    Private Sub AlerteTransaction(ByVal sender As Object, _
        ByVal Message As String)
        Console.WriteLine("Attention ! {0}", message)
    End Sub

    'Sabonner  lvnement Confirmation et utiliser le mot-cl Handles
    Private Sub ConfirmationTransaction(ByVal sender As Object, _
        ByVal message As String) Handles CompteCourant.Confirmation
        Console.WriteLine(message)
    End Sub

    Public Class CCompteCourant
        'Dclarer les vnements qui seront utiliss
        Public Event Confirmation(ByVal sender As Object, _
            ByVal Message As String)
        Public Event Alerte(ByVal sender As Object, ByVal Message As String)
        Private SoldeCourant As Double
        Private SoldeMinimal As Double

        Public Sub New(ByVal SoldeMinimal As Double)
            Me.SoldeMinimal = SoldeMinimal
        End Sub

        Public ReadOnly Property Solde(ByVal SoldeCourant As Double) _
            As Double
            Get
                Return Me.SoldeCourant
            End Get
        End Property

        'Dpt dargent sur le compte courant
        Public Sub Dpt(ByVal Montant As Double)
            SoldeCourant += Montant
            'Informer lutilisateur du dpt
            RaiseEvent Confirmation(Me, String.Format("Dpt : {0}; " & _
                "Nouveau solde : {1}", Montant, SoldeCourant))
        End Sub


        'Retrait dargent du compte courant
        Public Sub Retrait(ByVal Montant As Double)
            'Vrifier que le solde nest pas infrieur  0
            If (SoldeCourant - Montant) >= 0 Then
                SoldeCourant -= Montant
                'Informer lutilisateur du retrait
                RaiseEvent Confirmation(Me, String.Format("Retrait : {0}; " & _
                    "Nouveau solde : {1}", Montant, SoldeCourant))
                'Vrifier si le solde minimal a t atteint
                If SoldeCourant < SoldeMinimal Then
                    'Dclencher lvnement sur le dpassement du solde minimal
                    RaiseEvent Alerte(Me, String.Format("Vous tes sous " & _
                        "le solde minimal de {0}", SoldeMinimal))
                End If
            Else
                'Dclencher lvnement sur linsuffisance de fonds
                RaiseEvent Alerte(Me, String.Format("Fonds insuffisants : " & _
                    "{0} nont pas t retirs", Montant))
            End If
        End Sub
    End Class
End Module

