VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Gestion d'un compte courant en Visual Basic 6.0
'Copyright (c)2001, Bischof Systems, Inc.

'Dclarer la classe pour qu'elle identifie les vnements
' Dim WithEvents CompteCourant As CCompteCourant
Private Sub cmdExecute_Click()
    Set CompteCourant = New CCompteCourant
    CompteCourant.Init 50
    CompteCourant.Dpt 500
    CompteCourant.Retrait 400
    CompteCourant.Retrait 75
    CompteCourant.Retrait 50
    Set CompteCourant = Nothing
End Sub
'Grer l'vnement Confirmation
Private Sub CompteCourant_Confirmation(Message As String)
    Debug.Print Message
End Sub
'Grer l'vnement Alerte
Private Sub CompteCourant_Alerte(Message As String)
    Debug.Print "Alerte ! " & Message
End Sub

'Classe CCompteCourant
'Dclarer les vnements qui seront utiliss
Public Event Confirmation(Message As String)
Public Event Alerte(Message As String)
Private m_SoldeCourant As Double
Private m_SoldeMinimal As Double
Public Sub Init(SoldeMinimal As Double)
    m_SoldeMinimal = SoldeMinimal
End Sub
Public Property Get Solde() As Variant
    Solde = m_SoldeCourant
End Property

'Dpt d'argent sur le compte courant
Public Sub Dpt(Montant As Double)
    m_SoldeCourant = m_SoldeCourant + Montant
    'Informer l'utilisateur du dpt
    RaiseEvent Confirmation("Dpt : " & Montant & "; Nouveau solde : " & _
        m_SoldeCourant)
End Sub
'Retrait d'argent du compte courant
Public Sub Retrait(Montant As Double)
    'Vrifier que le solde n'est pas infrieur  zro
    If (m_SoldeCourant - Montant) >= 0 Then
        m_SoldeCourant = m_SoldeCourant - Montant
        'Informer l'utilisateur du retrait
        RaiseEvent Confirmation("Retrait : " & Montant & "; Nouveau solde : " & _
            m_SoldeCourant)
        'Vrifier si le solde minimal a t atteint
        If m_SoldeCourant < m_SoldeMinimal Then
            'Lever l'vnement sur le dpassement du solde minimal
            RaiseEvent Alerte("Vous tes sous le solde minimal de " & _
                m_SoldeMinimal)
        End If
    Else
        'Lever l'vnement sur l'insuffisance de fonds
        RaiseEvent Alerte("Fonds insuffisants - " & Montant & " n'ont pas t retirs")
    End If
End Sub


