'Utilisation de la date de votre anniversaire en Visual Basic .NET
'Copyright (c)2001, Bischof Systems, Inc.

Module Module1

    Sub Main()
        Dim anniversaire, prochainAnniversaire As DateTime
        Dim AujourdHui As DateTime = DateTime.Now
        Dim ts As TimeSpan
        Dim valeur As Integer
        'Rcuprer la date de naissance de lutilisateur
        Console.WriteLine("Quelle est votre date de naissance (00/00/0000) ?")
        anniversaire = DateTime.Parse(Console.ReadLine())
        'Est-ce une anne bissextile ?
        If (DateTime.IsLeapYear(anniversaire.Year)) Then
            Console.WriteLine("Vous tes n(e) une anne bissextile !")
        Else
            Console.WriteLine("Anne non bissextile")
        End If

        'Calculer la date du prochain anniversaire
        prochainAnniversaire = New DateTime(AujourdHui.Year, anniversaire.Month, _
            anniversaire.Day)
        If (AujourdHui.Month > anniversaire.Month) Then
            prochainAnniversaire = prochainAnniversaire.AddYears(1)
        End If
        Console.WriteLine("Date du prochain anniversaire : {0}", _
            prochainAnniversaire.ToShortDateString())
        'Utiliser la proprit Date pour la soustraction.
        ts = prochainAnniversaire.Subtract(AujourdHui.Date)
        Console.WriteLine("Il reste {0} jours jusqu votre anniversaire", ts.Days)
        'Que se passe-t-il si nous utilisons le type TimeSpan dans le calcul ?
        ts = prochainAnniversaire.Subtract(AujourdHui)
        Console.WriteLine("Utilisation de TimeSpan (non correcte) - Il reste {0} jours jusqu votre anniversaire", _
            ts.Days)
        Console.ReadLine()
    End Sub
End Module
