'Classe gnrique dinterface COM en Visual Basic .NET
'Copyright (c)2001, Bischof Systems, Inc.

Imports System.Reflection

Module Module1

    Sub Main()
        Dim version As String
        Dim fileSystem As CreateObject
        fileSystem = New CreateObject("Scripting.FileSystemObject")
        'Vous devrez peut-tre changer le chemin daccs
        version = fileSystem.Execute("GetFileVersion", _
            "C:\Windows\Explorer.exe").ToString
        Console.WriteLine("Windows Explorer - Version {0}", version)
        Console.ReadLine()
    End Sub

    'Classe gnrique pour accder  un objet COM avec la liaison tardive
    Public Class CreateObject
        'Dclarer les variables requises pour la liaison tardive
        Private comType As Type
        Private comObjet As Object
        'Le constructeur rcupre le ProgID de lobjet COM
        Public Sub New(ByVal ProgId As String)
            'Faire rfrence  linterface dobjet COM avec le ProgID
            comType = Type.GetTypeFromProgID(ProgID)
            'Instancier lobjet COM
            comObjet = Activator.CreateInstance(comType)
        End Sub
        'Appel gnrique dune mthode COM et retour dune valeur
        Public Function Execute(ByVal Method As String, _
            ByVal ParamArray Paramtres() As Object) As Object
            'Appeler la mthode de lobjet COM
            Return comType.InvokeMember(Method, BindingFlags.InvokeMethod, _
                Nothing, comObjet, Paramtres)
        End Function
    End Class
End Module
