'Classe RegEditor en Visual Basic .NET
'Copyright (c)2001, Bischof Systems, Inc.

Imports Microsoft.Win32

Module Module1

    Sub Main()
        Dim editeurReg As RegEditor
        Dim nomCl As String = "Best Sellers"
        Dim donnesCl As String = "Langages .NET : guide des quivalences"
        Dim donnesNouvelles As String
        'Indiquer  lutilisateur la cl qui va tre crite
        Console.WriteLine("criture dans la base de registre")
        Console.WriteLine("Nom de la cl : {0}", nomCl)
        Console.WriteLine("Valeur de la cl : {0}", donnesCl)
        'Instancier lditeur personnalis de la base de registre 
        editeurReg = New RegEditor("SOFTWARE/Eyrolles")
        'crire la chane dans la cl de la base du registre
        editeurReg.SetValue(nomCl, donnesCl)
        'Lecture dans une nouvelle variable pour sassurer quelle a fonctionn
        donnesNouvelles = editeurReg.GetValue(nomCl)
        Console.WriteLine("Lecture depuis la base de registre")
        Console.WriteLine("Valeur de la cl : {0}", donnesNouvelles)
        'Supprimer la cl aprs avoir termin
        Console.WriteLine("Suppression en cours...")
        editeurReg.DeleteValue(nomCl)
        donnesNouvelles = editeurReg.GetValue(nomCl)
        Console.WriteLine("Valeur de la cl : {0}", donnesNouvelles)
        Console.WriteLine("Termin")
        Console.ReadLine()
    End Sub

    'Les cls seront crites par la classe selon le chemin spcifi.
    'Classe conue pour utiliser la cl HKey_Local_Machine
    Public Class RegEditor
        Private clRegistre As RegistryKey
        'Chemin daccs de la base de registre requis par le constructeur
        Public Sub New(ByVal RegPath As String)
            clRegistre = GetRegistryKey(RegPath)
        End Sub
        'crire une valeur dans la base de registre
        Public Sub SetValue(ByVal KeyName As String, ByVal KeyValue As Object)
            clRegistre.SetValue(KeyName, KeyValue)
        End Sub
        'Lire une valeur dans la base de registre, renvoyer une chane pour 
        'des raisons de simplicit
        Public Function GetValue(ByVal KeyName As String) As String
            Return clRegistre.GetValue(KeyName)
        End Function
        'Supprimer la valeur de la cl
        Public Sub DeleteValue(ByVal KeyName As String)
            clRegistre.DeleteValue(KeyName)
        End Sub
        'Prendre un chemin de cl de base de registre et rcuprer la cl qui 
        'lui est associe
        Private Function GetRegistryKey(ByVal RegPath As String) As RegistryKey
            Dim clRegistre As RegistryKey
            Dim pathMembers() As String = RegPath.Split("/"c)
            Dim currentMember As Integer
            'Ici, le chemin racine est HKEY_LOCAL_MACHINE. Une modification 
            'judicieuse consisterait  utiliser un paramtre indiquant 
            'le chemin daccs racine.
            clRegistre = Registry.LocalMachine
            'Parcourir la base de registre jusqu obtenir la bonne cl
            For currentMember = 0 To pathMembers.Length - 1
                'Utiliser CreateSubKey pour vrifier lexistence de la cl
                clRegistre = clRegistre.CreateSubKey(pathMembers(currentMember))
            Next
            Return clRegistre
        End Function
    End Class
End Module
