'Enregistrement derreurs dans le journal des vnements en Visual Basic .NET
'Copyright (c)2001, Bischof Systems, Inc.

Imports System.Diagnostics

Module Module1

    Sub Main()
        Dim x, y As Integer
        Try
            x /= y
        Catch e As Exception
            JournalErreur(e, "Je savais que cela ne fonctionnerait pas!", True)
        End Try
    End Sub

    'Procdure standard denregistrement des erreurs
    Sub JournalErreur(ByVal e As Exception, ByVal MoreInfo As String, _
        ByVal Trace As Boolean)
        Dim messageErreur As String
        'Crer lobjet EventLog
        Dim log As EventLog = New EventLog()
        'Crer le message derreur
        messageErreur = e.Message
        If MoreInfo <> "" Then
            messageErreur += ", Autres infos : " + MoreInfo
        End If
        If Trace Then
            messageErreur += ", tat de la pile :" + e.StackTrace
        End If
        'Dfinir les proprits de lobjet EventLog
        log.Log = "Application"
        log.Source = e.Source
        'crire lentre
        log.WriteEntry(messageErreur)
        'Fermer le fichier de journalisation
        log.Close()
    End Sub
End Module
