//Exemple dapplication en C# calculant les rsultats dun test
//Copyright (c)2001, Bischof Systems, Inc.
using System;
namespace C_Fundamentals_TestScores
{
	class Class1
	{
		[STAThread]
		static void Main(string[] args)
		{
			TraiterScores(80, 90, 75);
			Console.ReadLine();
		}
		static public void TraiterScores(int Score1, int Score2, int Score3)
		{
			int MeilleurScore;
			float scoreMoyen;
			//Afficher les scores utiliss
			AfficherScores(Score1, Score2, Score3);
			//Lire le score le plus lev
			CalcMeilleurScore(Score1, Score2, Score3, out MeilleurScore);
			Console.WriteLine("Le score le plus lev est : {0}", MeilleurScore);
			//Lire le score moyen
			scoreMoyen = CalcScoreMoyen(Score1, Score2, Score3);
			Console.WriteLine("Le score moyen est : {0:N2}", scoreMoyen);
		}
		//Afficher tous les scores  laide dun tableau de paramtres
		static internal void AfficherScores(params int[] Scores)
		{
			Console.Write("Les scores utiliss sont : ");
			for (int scoreCourant = 0; scoreCourant < Scores.Length;
				scoreCourant++)
			{
				Console.Write(Scores[scoreCourant] + " ");
			}
			Console.WriteLine();
		}
		//Utiliser un paramtre out pour retourner le meilleur score
		static private void CalcMeilleurScore(int Score1, int Score2, int Score3,
			out int MeilleurScore)
		{
			//Imaginons que Score1 constitue le meilleur score
			MeilleurScore=Score1;
			//Score2 est-il meilleur ?
			if (Score2 > Score1)
			{
				MeilleurScore = Score2;
			}
			//Score3 est-il le meilleur score de tous ?
			if (Score3 > MeilleurScore)
			{
				MeilleurScore = Score3;
			}
		}
		//Utiliser une fonction pour calculer le score moyen
		static private float CalcScoreMoyen(params int[] Scores)
		{
			int scoreTotal=0;
			for (int scoreCourant = 0; scoreCourant < Scores.Length;
				scoreCourant++)
			{
				scoreTotal += Scores[scoreCourant];
			}
			return scoreTotal/(float)Scores.Length;
		}
	}
}
