//Dclaration et utilisation de variables en C#
//Copyright (c)2001, Bischof Systems, Inc.
using System;
namespace C_DataTypes_Variables
{
	class Class1
	{
		[STAThread]
		static void Main(string[] args)
		{
			ProcessScript("D1,Btrue,bfalse,I4453");
			Console.ReadLine();
		}
		private static void ProcessScript(string Script)
		{
			//Dclaration dun tableau et remplissage automatique de ses valeurs
			int[] JoursDuMois = new int[] {31, 28, 31, 30, 31, 30, 31, 31, 30,
											  31, 30, 31};
			//Les deux variables sont dclares avec le type DateTime
			DateTime premireDate, dernireDate;
			int DonnesEntires;
			string DonnesChane;
			bool DonnesBoolennes;
			char commande;
			string[] scripts;
			int CompteurScript;
			if (Script != "")
			{
				Console.WriteLine("Le script est : {0}", Script);
				//Division de la chane en un tableau de chanes spares par des virgules
				scripts = Script.Split(',');
				for (CompteurScript = 0; CompteurScript < scripts.Length;
					CompteurScript++)
				{
					commande = char.Parse(scripts[CompteurScript].Substring(0,1).
						ToUpper());
					DonnesChane = scripts[CompteurScript].Substring(1);
					switch(commande)
					{
						case 'B': //Boolen
							if (DonnesChane.ToUpper() == "TRUE")
							{
								DonnesBoolennes = true;
							}
							else
							{
								DonnesBoolennes = false;
							}
							Console.WriteLine("{0}",DonnesBoolennes.ToString());
							break;
						case 'D': //Date
							premireDate = DateTime.Parse(DonnesChane + "/1/" +
								DateTime.Today.Year);
							dernireDate = DateTime.Parse(DonnesChane + "/"
								+ JoursDuMois[int.Parse(DonnesChane) - 1]
								+ "/" + DateTime.Today.Year);
							Console.WriteLine("Dbut du mois : {0}",
								premireDate.ToShortDateString());
							Console.WriteLine("Fin du mois : {0}",
								dernireDate.ToShortDateString());
							break;
						case 'I': //Integer (entier)
							DonnesEntires = int.Parse(DonnesChane);
							Console.WriteLine(DonnesEntires);
							break;
					} //instruction switch
				} //instruction for
			} // instruction if
		} //ProcessScript
	} //classe
}
