'criture dans un fichier journal en Visual Basic .NET
'Copyright (c)2001, Bischof Systems, Inc.

Module Module1

    Sub Main()
        Classes()
        Console.ReadLine()
    End Sub

    Public Sub Classes()
        Dim CompteCourant As New CCompteCourant()
        CompteCourant.Dposer(500)
        CompteCourant.Retirer(400)
        CompteCourant.Retirer(75)
        CompteCourant.Retirer(50)
        CompteCourant.Dispose()
        CompteCourant = Nothing
    End Sub

    Public Class CCompteCourant
        Shared SoldeMinimal As Double = 100
        Private FichierJournal As IO.StreamWriter
        Private SoldeCourant As Double
        'Ouverture du fichier de sortie par le constructeur
        Public Sub New()
            FichierJournal = New IO.StreamWriter("C:\FichierJournal.txt")
        End Sub
        'Dpt dargent sur le compte courant
        Public Sub Dposer(ByVal Montant As Double)
            SoldeCourant += Montant
            FichierJournal.WriteLine("Dpt : {0}; Nouveau solde : {1}", _
                Montant, SoldeCourant)
        End Sub
        'Retrait dargent sur le compte courant
        Public Sub Retirer(ByVal Montant As Double)
            'Vrifier que le montant nest pas infrieur  0
            If (SoldeCourant - Montant) >= 0 Then
                SoldeCourant -= Montant
                'Enregistrer lexcution de la transaction
                FichierJournal.WriteLine("Retrait : {0}; Nouveau solde : {1}", _
                    Montant, SoldeCourant)
                'Vrifier si le solde minimal a t atteint
                If SoldeCourant < SoldeMinimal Then
                    'Enregistrer le dpassement du solde minimal
                    FichierJournal.WriteLine("Vous tes en dessous du solde minimal " & _
                        "de {0}", SoldeMinimal)
                End If
            Else
                'Enregistrer linsuffisance de fonds
                FichierJournal.WriteLine("Fonds insuffisants - {0} nont pas t " & _
                    "retirs", Montant)
            End If
        End Sub

        Public Sub Dispose()
            FichierJournal.Close()
            GC.SuppressFinalize(Me)
        End Sub
        Protected Overrides Sub Finalize()
            FichierJournal.Close()
        End Sub
    End Class
End Module

