VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'criture dans un fichier journal en Visual Basic 6.0
'Copyright (c)2001, Bischof Systems, Inc.

Option Explicit

Private Sub Main()
    Dim CompteCourant As CCompteCourant
    Set CompteCourant = New CCompteCourant
    CompteCourant.Init
    CompteCourant.Dposer 500
    CompteCourant.Retirer 400
    CompteCourant.Retirer 75
    CompteCourant.Retirer 50
    Set CompteCourant = Nothing
End Sub

'CCompteCourant class
Private m_SoldeCourant As Double
Private FichierJournal As Integer
Const m_SoldeMinimal = 100
Public Sub Init(Optional SoldeInitial As Double)
    m_SoldeCourant = SoldeInitial
End Sub
'Dpt d'argent sur le compte courant
Public Sub Dposer(Montant As Double)
    m_SoldeCourant = m_SoldeCourant + Montant
    Write #FichierJournal, "Dpt : " & Montant & "; Nouveau solde : " & _
        m_SoldeCourant
End Sub

'Retrait d'argent sur le compte courant
Public Sub Retirer(Montant As Double)
    'Vrifier que le solde n'est pas infrieur  zro
    If (m_SoldeCourant - Montant) >= 0 Then
        m_SoldeCourant = m_SoldeCourant - Montant
    
        'Enregistrer l'excution de la transaction
        Write #FichierJournal, "Retrait : " & Montant & "; Nouveau solde : " & _
            m_SoldeCourant
        'Vrifier si le solde minimal a t atteint
        If m_SoldeCourant < m_SoldeMinimal Then
            'Enregistrer le dpassement du solde minimal
            Write #FichierJournal, "Vous tes en dessous du solde minimal de " & _
                m_SoldeMinimal
        End If
    Else
        'Enregistrer l'insuffisance de fonds
        Write #FichierJournal, "Fonds insuffisants - " & Montant & " n'ont pas t " & _
            "retirs"
    End If
    
End Sub

Private Sub Class_Initialize()
    FichierJournal = FreeFile
    Open "C:\FichierJournal.txt" For Output As #FichierJournal
End Sub

Private Sub Class_Terminate()
    Close #FichierJournal
End Sub


