'Affichage et mise  jour de la base de donnes Comptoir en Visual Basic .NET
'Copyright (c)2001, Bischof Systems, Inc.

Imports System.Data
Imports System.Data.OleDb

Module Module1

    Sub Main()
        'Dclarez les objets OleDb
        Dim dbCn As OleDbConnection
        Dim dbCmd As OleDbCommand
        Dim dbDa As OleDbDataAdapter
        Dim dbBldr As OleDbCommandBuilder
        Dim dbDr As OleDbDataReader
        'Dclarez les objets Data
        Dim ds As DataSet
        Dim dt As DataTable
        Dim dr As DataRow
        'Dclarez les variables dentre utilisateur
        Dim slection As Integer, CompteurLigne As Integer
        Dim entre As String
        'Ouvrir la connexion de base de donnes
        dbCn = New OleDbConnection("Provider=Microsoft.JET.OLEDB.4.0;" & _
            "Data Source=C:\Comptoir.mdb")
        dbCn.Open()
        'Prparer linstruction SQL
        dbCmd = New OleDbCommand("Messagers", dbCn)
        dbCmd.CommandType = CommandType.TableDirect
        'Lire la table dans le DataSet avec le DataAdapter
        ds = New DataSet()
        dbDa = New OleDbDataAdapter()
        dbDa.SelectCommand = dbCmd
        dbDa.Fill(ds, "Messagers")
        dbBldr = New OleDbCommandBuilder(dbDa)
        'Dfinir une rfrence  la table
        dt = ds.Tables("Messagers")
        'Ne pas conserver la connexion ouverte au-del du temps ncessaire
        dbCn.Close()
        Console.WriteLine("ADO .NET")

        Do
            Console.WriteLine()
            Console.WriteLine("1. Afficher la table en mmoire")
            Console.WriteLine("2. Afficher la table physique")
            Console.WriteLine("3. Modifier un enregistrement")
            Console.WriteLine("4. Ajouter un enregistrement")
            Console.WriteLine("5. Supprimer un enregistrement")
            Console.WriteLine("6. Valider les modifications dans la base de donnes")
            Console.Write("Votre choix : ")
            slection = Integer.Parse("0" & Console.ReadLine())
            Select Case slection
                Case 1 'Afficher la table charge en mmoire
                    Console.WriteLine()
                    For CompteurLigne = 0 To dt.Rows.Count - 1
                        dr = dt.Rows(CompteurLigne)
                        If dr.RowState() <> DataRowState.Deleted Then
                            Console.WriteLine("Ligne #{0}: {1} {2} {3}", _
                            CompteurLigne + 1, dr(0), dr(1).ToString.PadRight(30), _
                            dr(2))
                        End If
                    Next
                Case 2      'Afficher la table de la base de donnes physique
                    Console.WriteLine()
                    CompteurLigne = 1
                    dbCn.Open()
                    dbDr = dbCmd.ExecuteReader()
                    While (dbDr.Read())
                        Console.WriteLine("Ligne #{0}: {1} {2} {3}", CompteurLigne, _
                        dbDr.GetInt32(0), dbDr.GetString(1).PadRight(30), _
                        dbDr.GetString(2))
                        CompteurLigne += 1
                    End While
                    dbDr.Close()
                    dbCn.Close()
                Case 3     'Modifier une ligne en fonction de la cl primaire
                    Console.Write("Quel Numro  ?")
                    entre = Console.ReadLine()
                    'Dfinir le filtre pour obtenir la ligne slectionne
                    dr = dt.Select("[N messager] = " & entre)(0)
                    'Rcuprer les modifications de lutilisateur
                    Console.Write("En cours : {0} Nouveau : ", dr("Socit"))
                    entre = Console.ReadLine()

                    If (entre <> "") Then
                        dr("Socit") = entre
                    End If
                    Console.Write("En cours : {0} Nouveau : ", dr("Tlphone"))
                    entre = Console.ReadLine()
                    If (entre <> "") Then
                        dr("Tlphone") = entre
                    End If
                Case 4 'Ajouter une nouvelle ligne
                    'Crer lobjet ligne (row) et le remplir
                    dr = dt.NewRow()
                    Console.Write("Entreprise : ")
                    entre = Console.ReadLine()
                    dr("Socit") = entre
                    Console.Write("Tlphone : ")
                    entre = Console.ReadLine()
                    dr("Tlphone") = entre
                    'Ajouter lobjet row  la collection
                    dt.Rows.Add(dr)
                Case 5     'Supprimer une ligne  laide de lindex
                    Console.Write("Numro de ligne : ")
                    entre = Console.ReadLine()
                    'Supprimer lenregistrement 
                    dt.Rows(Integer.Parse(entre) - 1).Delete()
                Case 6      'Valider les modifications dans la base de donnes
                    'SQLCommandBuilder valide les modifications pour vous
                    dbDa.Update(ds, "Messagers")
                    dt.AcceptChanges()
                    'Effacer la table courante et lactualiser
                    dt.Reset()
                    dbDa.Fill(ds, "Messagers")
            End Select
        Loop While (slection <> 0)
    End Sub
End Module


