//Utilisation de la date de votre anniversaire en C#
//Copyright (c)2001 by Bischof Systems, Inc.

using System;

namespace C_Birthday
{
	class Class1
	{
		[STAThread]
		static void Main(string[] args)
		{
			DateTime anniversaire, prochainAnniversaire;
			DateTime aujourdhui = DateTime.Now;
			TimeSpan ts;
			int valeur;      
			//Rcuprer la date de naissance de lutilisateur
			Console.WriteLine("Quelle est votre date de naissance (00/00/0000) ?");
			anniversaire = DateTime.Parse(Console.ReadLine());            

			//Est-ce une anne bissextile ?
			if (DateTime.IsLeapYear(anniversaire.Year))
			{
				Console.WriteLine("Vous tes n(e) une anne bissextile !");
			}
			else
			{
				Console.WriteLine("Anne non bissextile");
			}
			//Calculer la date du prochain anniversaire
			prochainAnniversaire = new DateTime(aujourdhui.Year, anniversaire.Month,
				anniversaire.Day);
			if (aujourdhui.Month > anniversaire.Month)
			{
				prochainAnniversaire = prochainAnniversaire.AddYears(1);
			} 
			Console.WriteLine("Date du prochain anniversaire : {0}",
				prochainAnniversaire.ToShortDateString());
			//Utiliser la proprit Date pour la soustraction.
			ts = prochainAnniversaire.Subtract(aujourdhui.Date);
			Console.WriteLine("Il reste {0} jours jusqu votre anniversaire", ts.Days);
			//Que se passe-t-il si nous utilisons le type TimeSpan dans le calcul ?
			ts = prochainAnniversaire.Subtract(aujourdhui);
			Console.WriteLine("Utilisation de TimeSpan (non correct) - Il reste {0} jours"
				+ "jusqu votre anniversaire", ts.Days);            
			Console.ReadLine();
		}
	}
}
