//Fonctions financires en C#
//Copyright (c)2001, Bischof Systems, Inc.

using System;
//La ligne suivante ncessite lajout dune rfrence  la bibliothque
//Microsoft Visual Basic.NET Runtime 
using Microsoft.VisualBasic;

namespace C_Financial
{
	class Class1
	{
		[STAThread]
		static void Main(string[] args)
		{
			double taux, pr, nbpr, pmt, vp, vf; 
			int slection;
			double rsultat=0;
			Console.WriteLine("Fonctions financires\n");
			Console.WriteLine("Menu");
			Console.WriteLine("1. Valeur actuelle (Taux,Annes,PMT,VC) ");
			Console.WriteLine("2. Valeur capitalise (Taux,Annes,PMT,VA)");
			Console.WriteLine("3. Intrts pays (Taux,Pr,Annes,VA,VC)");
			Console.WriteLine("4. Paiement mensuel (Taux,Annes,VA,VC)");
			Console.Write("Choisir une fonction : ");
			slection = int.Parse(Console.ReadLine());
			Console.WriteLine("Tapez une valeur approprie (ou 0 pour lignorer)");
			Console.Write("Taux dintrt - nombre entier : ");
			//Le taux dintrt doit tre converti en pourcentage
			//puis en valeur par mois
			taux = (double.Parse(Console.ReadLine())/100)/12;
			Console.Write("Priode : ");
			pr = double.Parse(Console.ReadLine());
			Console.Write("Nombre dannes : ");
			//Convertir le nombre dannes en nombre de remboursements mensuels
			nbpr= double.Parse(Console.ReadLine())*12;
			Console.Write("Paiement : ");
			pmt = double.Parse(Console.ReadLine());
			Console.Write("Valeur actuelle : ");
			//La valeur prsente doit tre un nombre ngatif
			vp = double.Parse(Console.ReadLine())*-1;
			Console.Write("Valeur capitalise :  ");
			vf = double.Parse(Console.ReadLine());
			switch(slection)
			{
				case 1: //Valeur actuelle
					rsultat = Financial.PV(taux, nbpr, pmt, vf, 
						DueDate.EndOfPeriod);
					break;
				case 2: //Valeur capitalise
					rsultat = Financial.FV(taux, nbpr, pmt, vp, 
						DueDate.EndOfPeriod);
					break;
				case 3: //Intrts pays
					rsultat = Financial.IPmt(taux, pr, nbpr, vp, vf, 
						DueDate.EndOfPeriod);
					break;
				case 4: //Paiement mensuel
					rsultat = Financial.Pmt(taux, nbpr, vp, vf, 
						DueDate.EndOfPeriod);
					break;
			}

			Console.WriteLine("Rsultat : {0}", String.Format
				(rsultat.ToString("n")));
			Console.ReadLine();
		}
	}
}
