//Classe gnrique dinterface COM en C#
//Copyright (c)2001, Bischof Systems, Inc.

using System;
using System.Reflection;

namespace C_LateBindingGeneric
{
	class Class1
	{
		[STAThread]
		static void Main(string[] args)
		{
			string version;
			CreateObject fileSystem;
			fileSystem = new CreateObject("Scripting.FileSystemObject");
			//Vous devrez peut-tre changer le chemin daccs 
			version = (string)fileSystem.Execute("GetFileVersion", 
				@"C:\Windows\Explorer.exe");
			Console.WriteLine("Windows Explorer - Version {0}", version);
			Console.ReadLine();
		}
	}
	//Classe gnrique pour accder  un objet COM avec la liaison tardive
	public class CreateObject
	{
		//Dclarer les variables requises pour la liaison tardive
		private Type comType;
		private object comObjet;
		//Le constructeur rcupre le ProgID de lobjet COM
		public CreateObject(string ProgID)
		{
			//Faire rfrence  linterface dobjet COM avec le ProgID
			comType = Type.GetTypeFromProgID(ProgID);
			//Instancier lobjet COM
			comObjet = Activator.CreateInstance(comType);
		}

		//Appel gnrique dune mthode COM liaison tardive et retour dune valeur
		public object Execute(string Method, params object[] Paramtres)
		{
			//Appeler la mthode de lobjet COM
			return comType.InvokeMember(Method,BindingFlags.InvokeMethod,
				null,comObjet,Paramtres);
		}
	}
}
