//Enregistrement derreurs dans le journal des vnements en C#
//Copyright (c)2001 by Bischof Systems, Inc.

using System;
using System.Diagnostics;

namespace Event_Log
{
	class Class1
	{
		[STAThread]
		static void Main(string[] args)
		{
			int x=0, y=0;
			try
			{
				x /= y;
			}
			catch (Exception e)
			{
				JournalErreur(e, "Je savais que cela ne fonctionnerait pas!", true);
			}
		}

		//Procdure standard denregistrement des erreurs
		static void JournalErreur(Exception e, string MoreInfo, bool Trace)
		{
			string messageErreur;
			//Crer lobjet EventLog
			EventLog log = new EventLog();
			//Crer le message derreur
			messageErreur = e.Message;

			if (MoreInfo != "")
			{
				messageErreur += ", Autres infos : " + MoreInfo;
			}
			if (Trace) 
			{
				messageErreur += ", tat de la pile :" + e.StackTrace;
			}
			//Dfinir les proprits de lobjet EventLog
			log.Log = "Application";
			log.Source = e.Source;
			//crire lentre
			log.WriteEntry(messageErreur);
			//Fermer le fichier de journalisation
			log.Close();
		}
	}        
}
